#Siamfcos

This repository includes PyTorch code for reproducing the results on VOT2019.

[**Siamese Fully Convolutional One-Stage Network for Short-Term Tracking**] 

Chen Xier, Lian Yanchao,Li Yingping, Chen Yanan


## Introduction

**Siamfcos** improves the performance by (1) using the data of VID, part of GOT 10k and COCO to train model, (2)adopting the idea of SiamRPN plus plus to extract multi-resolution features, the classification method and anchorfree regression method of FCOS detection algorithm to classify and to regress, (3)using different methods to deal with the problem of target edge disappearance and occlusion. (4) A model like GMM is used to store and update template images in online tracking.


## Prerequisites
operating system: ubuntu 16.04
CPU: Intel(R) Xeon(R) CPU E5-2620 0 @ 2.00GHz  24
GPU: NVIDIA Corporation GM200 [GeForce GTX TITAN X/PCIe/SSE2]

- python3.6.6
- pytorch == 1.0.1
- torchvision
- numpy
- opencv
- lmdb
- fire
- pandas
- glob
- os
- tqdm
- matplotlib


## Detailed steps to install the prerequisites
- install pytorch, numpy, torchvision, opencv, lmdb, fire, pandas, glob, os, tqdm, matplotlib  following the instructions in the `run_install.sh`. Please do **not** use conda to install.
- you can alternatively modify '/PATH/TO/CODE/FOLDER/' in 'tracker_Siamfcos.m'


## Get model weight
# Get our tracker's weight
- download the weight from 'https://pan.baidu.com/s/1ruYKWKjgt8yw__2H_WCveA' with the key 'pzn8' (if have any problem, please contact us by sending email to xechen@stu.xidian.edu.cn)
- put the weight in path 'experimental_results/cocovidgot/checkpoints'


## Test with our model
CPU_version: python demo_cpu.py --video_dir=/PATH/OF/THE/VIEDO --model_path=experimental_results/cocovidgot/checkpoints/cocovidgot_val2.274885892868042_net_epoch15
GPU_version: python demo_gpu.py --video_dir=/PATH/OF/THE/VIEDO --model_path=experimental_results/cocovidgot/checkpoints/cocovidgot_val2.274885892868042_net_epoch15


## Test by vot-toolkit
use vot_Siamfcos_cpu.py to test on CPU,or vot_Siamfcos_gpu.py to test on GPU.

