from .resnet_atrous import *
from .RPN_new import *
from .neck import *

class SiamRPN(nn.Module):
    def __init__(self):
        super(SiamRPN, self).__init__()
        self.backbone = resnet50()
        self.neck1 = AdjustAllLayer()
        # self.neck2 = AdjustAllLayer()
        # self.search_region_branch = resnet50()
        self.conv3_3_RPN = RPN()
        self.conv4_6_RPN = RPN()
        self.conv5_3_RPN = RPN()

        # self.extra_1x1_conv3 = nn.Conv2d(
        #     512, 256, kernel_size=1, stride=1, padding=0, bias=False)
        # self.extra_1x1_conv4 = nn.Conv2d(
        #     1024, 256, kernel_size=1, stride=1, padding=0, bias=False)
        # self.extra_1x1_conv5 = nn.Conv2d(
        #     2048, 256, kernel_size=1, stride=1, padding=0, bias=False)

        self.weighted_sum_layer_a1 = nn.Conv2d(
            6, 6, kernel_size=1, padding=0, groups=2)
        self.weighted_sum_layer_a2 = nn.Conv2d(
            6, 2, kernel_size=1, padding=0, groups=2)
        self.weighted_sum_layer_b1 = nn.Conv2d(
            3, 3, kernel_size=1, padding=0, groups=1)
        self.weighted_sum_layer_b2 = nn.Conv2d(
            3, 1, kernel_size=1, padding=0, groups=1)
        self.weighted_sum_layer_c1 = nn.Conv2d(
            12, 12, kernel_size=1, padding=0, groups=4)
        self.weighted_sum_layer_c2 = nn.Conv2d(
            12, 4, kernel_size=1, padding=0, groups=1)
        self.examplar_conv_3_output = []
        self.examplar_conv_4_output = []
        self.examplar_conv_5_output = []

    def forward(self, examplar, search_region):
        examplar_conv_3_output, examplar_conv_4_output, examplar_conv_5_output = self.backbone(
            examplar)
        search_region_conv_3_output, search_region_conv_4_output, search_region_conv_5_output = self.backbone(search_region)
        # examplar_conv_3_output = self.extra_1x1_conv3(examplar_conv_3_output)
        # examplar_conv_4_output = self.extra_1x1_conv4(examplar_conv_4_output)
        # examplar_conv_5_output = self.extra_1x1_conv5(examplar_conv_5_output)
        # search_region_conv_3_output = self.extra_1x1_conv3(search_region_conv_3_output)
        # search_region_conv_4_output = self.extra_1x1_conv4(search_region_conv_4_output)
        # search_region_conv_5_output = self.extra_1x1_conv5(search_region_conv_5_output)
        examplar_conv_3_output, examplar_conv_4_output, examplar_conv_5_output = self.neck1([examplar_conv_3_output, examplar_conv_4_output, examplar_conv_5_output])
        search_region_conv_3_output, search_region_conv_4_output, search_region_conv_5_output = self.neck1(
            [search_region_conv_3_output, search_region_conv_4_output, search_region_conv_5_output])

        conv3_3_class_prediction, conv3_3_center_prediction, conv3_3_bbox_regression_prediction = self.conv3_3_RPN(
            examplar_conv_3_output, search_region_conv_3_output, search_region.size()[0])
        conv4_6_class_prediction, conv4_6_center_prediction, conv4_6_bbox_regression_prediction = self.conv4_6_RPN(
            examplar_conv_4_output, search_region_conv_4_output, search_region.size()[0])
        conv5_3_class_prediction, conv5_3_center_prediction, conv5_3_bbox_regression_prediction = self.conv5_3_RPN(
            examplar_conv_5_output, search_region_conv_5_output, search_region.size()[0])
        # ipdb.set_trace()
        stacked_cls_prediction = torch.cat((conv3_3_class_prediction, conv4_6_class_prediction, conv5_3_class_prediction), 2).reshape(
            search_region.size()[0], 2, -1, 25, 25).reshape(search_region.size()[0], -1, 25, 25)
        stacked_center_prediction = torch.cat((conv3_3_center_prediction, conv4_6_center_prediction, conv5_3_center_prediction), 2).reshape(
            search_region.size()[0], 1, -1, 25, 25).reshape(search_region.size()[0], -1, 25, 25)
        stacked_regression_prediction = torch.cat(
            (conv3_3_bbox_regression_prediction, conv4_6_bbox_regression_prediction, conv5_3_bbox_regression_prediction), 2).reshape(search_region.size()[0], 4, -1, 25, 25).reshape(search_region.size()[0], -1, 25, 25)
        # ipdb.set_trace()
        fused_cls_prediction = self.weighted_sum_layer_a1(
            stacked_cls_prediction)
        fused_cls_prediction = self.weighted_sum_layer_a2(
            fused_cls_prediction)
        fused_center_prediction = self.weighted_sum_layer_b1(
            stacked_center_prediction)
        fused_center_prediction = self.weighted_sum_layer_b2(
            fused_center_prediction)
        fused_regression_prediction = self.weighted_sum_layer_c1(
            stacked_regression_prediction)
        fused_regression_prediction = self.weighted_sum_layer_c2(
            fused_regression_prediction)
        return fused_cls_prediction, fused_center_prediction, fused_regression_prediction


    # def track_init(self, template):
    #     _, examplar_conv_3_output, examplar_conv_4_output, examplar_conv_5_output = self.examplar_branch(
    #         template)
    #     self.examplar_conv_3_output = examplar_conv_3_output
    #     self.examplar_conv_4_output = examplar_conv_4_output
    #     self.examplar_conv_5_output = examplar_conv_5_output
    # def track(self, detection):
    #     _, search_region_conv_3_output, search_region_conv_4_output, search_region_conv_5_output = self.search_region_branch(
    #         detection)
    #
    #     conv3_3_class_prediction, conv3_3_center_prediction, conv3_3_bbox_regression_prediction = self.conv3_3_RPN(
    #         self.examplar_conv_3_output, search_region_conv_3_output, detection.size()[0])
    #     conv4_6_class_prediction, conv4_6_center_prediction, conv4_6_bbox_regression_prediction = self.conv4_6_RPN(
    #         self.examplar_conv_4_output, search_region_conv_4_output, detection.size()[0])
    #     conv5_3_class_prediction, conv5_3_center_prediction, conv5_3_bbox_regression_prediction = self.conv5_3_RPN(
    #         self.examplar_conv_5_output, search_region_conv_5_output, detection.size()[0])
    #     # ipdb.set_trace()
    #     stacked_cls_prediction = torch.cat(
    #         (conv3_3_class_prediction, conv4_6_class_prediction, conv5_3_class_prediction), 2).reshape(
    #         detection.size()[0], 2, -1, 25, 25).reshape(detection.size()[0], -1, 25, 25)
    #     stacked_center_prediction = torch.cat(
    #         (conv3_3_center_prediction, conv4_6_center_prediction, conv5_3_center_prediction), 2).reshape(
    #         detection.size()[0], 1, -1, 25, 25).reshape(detection.size()[0], -1, 25, 25)
    #     stacked_regression_prediction = torch.cat(
    #         (
    #         conv3_3_bbox_regression_prediction, conv4_6_bbox_regression_prediction, conv5_3_bbox_regression_prediction),
    #         2).reshape(detection.size()[0], 4, -1, 25, 25).reshape(detection.size()[0], -1, 25, 25)
    #     # ipdb.set_trace()
    #     fused_cls_prediction = self.weighted_sum_layer_a1(
    #         stacked_cls_prediction)
    #     fused_cls_prediction = self.weighted_sum_layer_a2(
    #         fused_cls_prediction)
    #     fused_center_prediction = self.weighted_sum_layer_b1(
    #         stacked_center_prediction)
    #     fused_center_prediction = self.weighted_sum_layer_b2(
    #         fused_center_prediction)
    #     fused_regression_prediction = self.weighted_sum_layer_c1(
    #         stacked_regression_prediction)
    #     fused_regression_prediction = self.weighted_sum_layer_c2(
    #         fused_regression_prediction)
    #     return fused_cls_prediction, fused_center_prediction, fused_regression_prediction

if __name__ == '__main__':
    x=torch.randn(10,3,256,256).float()
    z=torch.randn(10,3,127,127).float()
    net = SiamRPN()
    # checkpoint = torch.load('/home/lyc/Documents/VOT2019/experiments/siamrpn_r50_l234_dwxcorr_lt/model.pth')
    # net.load_state_dict(checkpoint)
    A=net(z, x)
    print(A)