# -*- coding: utf-8 -*
import vot
from vot import Rectangle
handle = vot.VOT("polygon")
Polygon = handle.region()
import sys
import cv2
# import torch
import numpy as np
from os.path import realpath, dirname, join

import glob
import os
import pandas as pd
import argparse
import numpy as np
import cv2
import time
import sys
import matplotlib.pyplot as plt

sys.path.append(os.getcwd())
from tqdm import tqdm
from tracker_gpu import SiamFCOSTracker
from utils.utils import get_axis_aligned_bbox, cxy_wh_2_rect


net_file = join(realpath(dirname(__file__)),
                'experimental_results/cocovidgot/checkpoints/cocovidgot_val2.274885892868042_net_epoch15')
tracker = SiamFCOSTracker(net_file)

# start to track

[cx, cy, w, h] = get_axis_aligned_bbox(Polygon)  # 左上角，宽高
bbox = [cx - w/2 + 0.5, cy - h/2 + 0.5, w, h]
image_file = handle.frame()
if not image_file:
    sys.exit(0)

frame = cv2.imread(image_file)  # HxWxC
frame = cv2.cvtColor(frame, cv2.COLOR_BGR2RGB)

z = tracker.init(frame, bbox)  # init tracker

while True:
    image_file = handle.frame()
    if not image_file:
        break
    frame = cv2.imread(image_file)
    frame = cv2.cvtColor(frame, cv2.COLOR_BGR2RGB)  # HxWxC
    bbox, score_pred, _, fore_pixels5, fore_pixels9, p_95 = tracker.update(frame)  # track
    bbox = (bbox[0] - bbox[2] / 2 + 0.5, bbox[1] - bbox[3] / 2 + 0.5,
            bbox[0] + bbox[2] / 2 - 0.5, bbox[1] + bbox[3] / 2 - 0.5)

    handle.report(Rectangle(bbox[0].astype(np.int), bbox[1].astype(np.int), bbox[2].astype(np.int) - bbox[0].astype(np.int), bbox[3].astype(np.int) - bbox[1].astype(np.int)))
